'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactabularColumnExtensions = require('reactabular-column-extensions');

var extensions = _interopRequireWildcard(_reactabularColumnExtensions);

var _sortabular = require('sortabular');

var sort = _interopRequireWildcard(_sortabular);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function bindColumns(_ref) {
  var window = _ref.window,
      _ref$props = _ref.props,
      props = _ref$props === undefined ? {} : _ref$props,
      onDragColumnStart = _ref.onDragColumnStart,
      onDragColumn = _ref.onDragColumn,
      onDragColumnEnd = _ref.onDragColumnEnd,
      onSort = _ref.onSort,
      onMoveColumns = _ref.onMoveColumns,
      onToggleShowingChildren = _ref.onToggleShowingChildren,
      _ref$idField = _ref.idField,
      idField = _ref$idField === undefined ? 'id' : _ref$idField,
      _ref$parentField = _ref.parentField,
      parentField = _ref$parentField === undefined ? 'parent' : _ref$parentField,
      toggleChildrenProps = _ref.toggleChildrenProps,
      sortingColumns = _ref.sortingColumns,
      rows = _ref.rows;

  return extensions.bind([extensions.draggableHeader({
    onMoveColumns: onMoveColumns
  }), extensions.highlightCell(), extensions.sortableHeader({
    sortingColumns: sortingColumns,
    onSort: onSort,
    props: props.sort,
    strategy: sort.strategies.byProperty
  }), extensions.resizableHeader({
    window: window,
    onDragColumnStart: onDragColumnStart,
    onDragColumn: onDragColumn,
    onDragColumnEnd: onDragColumnEnd,
    props: props.resize
  }), extensions.toggleChildrenCell({
    idField: idField,
    parentField: parentField,
    onToggleShowingChildren: onToggleShowingChildren,
    props: toggleChildrenProps,
    rows: rows
  })]);
}

exports.default = bindColumns;